#include "cs537.h"

/*
 * CS537 Project 2
 *
 * This program is intended to help you test your web server.
 * You can use it to test that you are correctly having multiple threads
 * handling http requests.
 * 
 *
 */

int outer = 5;
int inner = 10;
long max_usleep = 1000000; // 1 second
int seed = 1;

void getargs()
{
  char *buf, *p;

  /* Extract the four arguments */
  if ((buf = getenv("QUERY_STRING")) != NULL) {
    p = strtok(buf, "&");
    if (p == NULL) 
      return;
    outer = atoi(p);
    p = strtok(NULL, "&");
    if (p == NULL) 
      return;
    inner = atoi(p);
    p = strtok(NULL, "&");
    if (p == NULL) 
      return;
    max_usleep = atoi(p);
    p = strtok(NULL, "&");
    if (p == NULL) 
      return;
    seed = atoi(p);
  }
}


int main(int argc, char *argv[])
{
  int i;
  int j;
  int count = 0;
  char content[MAXBUF];

  long usec, total_sleep = 0;

  getargs();

  for (i = 0; i < outer; i++) {

    for (j = 0; j < inner; j++) {
      count++;
    }

    usec = max_usleep * ((float)rand() / (float)RAND_MAX);
    usleep(usec);
    total_sleep += usec;
  }


  /* Make the response body */
  sprintf(content, "Welcome to the CGI program: %s\r\n", argv[0]);
  sprintf(content, "%sMy only purpose is to waste time on the server!\r\n", 
	  content);
  sprintf(content, "%sI slept for a total of %lf seconds\r\n", 
	  content, (double)total_sleep/1e6);
  sprintf(content, "%sI incremented my counter to %d\r\n", 
	  content, count);
  sprintf(content, "%sThanks!\r\n", content);
  
  /* Generate the HTTP response */
  printf("Content-length: %d\r\n", strlen(content));
  printf("Content-type: text/html\r\n\r\n");
  printf("%s", content);
  fflush(stdout);

  exit(0);
}

