#ifndef __MY_THREAD_
#define __MY_THREAD_

#include <pthread.h>
#include "mywrappers.c"

typedef struct __my_thread_t
{	pthread_t *t;
	int thread_id;
  	int thread_count;
  	int static_count;
  	int dynamic_count;
} my_thread;

my_thread *newThread(int tid)
{	my_thread *tptr = (my_thread *)Malloc(sizeof(my_thread));
	tptr->thread_id = tid;
	tptr->thread_count = 0;
	tptr->static_count = 0;
	tptr->dynamic_count = 0;
	return tptr;
}

void freeThread(my_thread *tptr)
{	free(tptr);
}

#endif
